const mysqlAsync = require('promise-mysql');
const phantom = require('phantom');
const _ = require('lodash');

class CamerBeScrapComponent {
	constructor() {
		this.selector = '.card-deck h5.card-title a';
	}

	init(app, route) {
		app.get(route, this.runScrap.bind(this));
	}

	getAssyncConnection() {
		return mysqlAsync.createConnection({
		    host     : 'localhost',
			user     : 'jetcamer_admin',
			password : '123_JET_!!!',
		});
	}

	send(res, success_msg, error_msg, req) {
		try{		
			if(req && req.query && req.query.callback !== undefined){			
				res.send(200, req.query.callback + "("+ success_msg +")");		
			}else{			
				res.send(200, success_msg);		
			}
		}catch(e){
			console.log(success_msg);
		}
	}

	runScrap(req, res) {
		const that = this;
		phantom.create().then((ph) => {
		    ph.createPage().then((page) => {
		    	page.on('onConsoleMessage', (msg) => { 
		    		var finalObj = {};
		    		try { finalObj = JSON.parse(msg) } catch(e){ console.log(msg); };
		    		if(finalObj.action === 'done') {
	    				this.getMediaData(finalObj.data); 
	    				page.close().then(function(){
		    				ph.exit();
		    			});
		    		}
		    	});
		        page.open('http://camer.be').then((status) => {
		            page.includeJs("https://jetcamer.com/cameroon/plugins/jquery/jquery-2.1.0.min.js").then(function() {
		                
		            })
		            .then((result) => {
		            	var title = page.evaluate(function (selector) {
		            		var $elts = $(selector);
		            		var titles = [];
		            		var links = [];
		            		var data = [];
		            		$.each($elts, function(idx, elt){
		            			titles.push($(elt).text())
		            			links.push($(elt).attr('href'))
		            			data.push({link: $(elt).attr('href'), title: $(elt).text()})
		            		});

		            		console.log(JSON.stringify({action: 'done', data: data}));

						}, this.selector);
		            })
		            .catch(function(e) {
		                console.log(e);
		            });
		        });
		    });
		});

		this.send(res, '{success: true}');
	}

	getMediaData(data){
		if(data.length == 0) return;

		const start = () => {
			const processNext = (page, ph) => {
				page.close().then(function(){
					console.log('exiting...');
					ph.exit();
				});

				data.shift(); // Remove 1st elt
				this.getMediaData(data);
			}

			phantom.create().then((ph) => {
			    ph.createPage().then((page) => {
			    	page.on('onConsoleMessage', (msg) => { 
			    		var finalObj = {};
			    		try { finalObj = JSON.parse(msg) } catch(e){ console.log(msg); };
			    		if(finalObj.action === 'scrap') {
			    			if(data.length === 0) {
				    			return;
			    			}

			    			processNext(page, ph);
			    		}
			    	});

			    	var pageData = data[0];
			    	this.getAssyncConnection()
					.then((conn)=>{
						var link = conn.escape(pageData.link);
						var q = `select id from jetcamer_sociopo.jos_content where source = ${link}`;
						console.log(q);
						var promise = conn.query(q);
						conn.end();
						return promise;
					})
					.then((rows)=>{
						if(rows.length !== 0) {
							console.log('exist, do next...');
							processNext(page, ph);
			    			return;
						}

						page.open(pageData.link).then(function(status) {
				            page.includeJs("https://jetcamer.com/cameroon/plugins/jquery/jquery-2.1.0.min.js").then(function() {
				                
				            })
				            .then(function(result) {
				            	var title = page.evaluate(function (dataStr) {
				            		var data = $.parseJSON(dataStr);
					        		console.log('evaluated...', data);
					        		var article = $('.article-content__left-column p, .text-justify.info p');
					        		var image = $('img.card-img-top').attr('src');
					        		var text = $('<div/>').append(article).html();

					        		console.log('done for:', image, text);
					        		var data = {saveNewsToDB: 1, state: 1, title: data.title, text: text, image: image, catid: 32, url: data.link};
					        		console.log(JSON.stringify(data));
					        		//*
					        		$.ajax({
									    url:'http://jetcamer.com/ws/json.php',
									    data: data,
									    method:'post',
									    success: function(resp) {
								    	  console.log('response');
									      console.log(resp);
									      // trigger the onConsoleMessage to continue the scraping process
				        				  console.log(JSON.stringify({action: 'scrap'}));
									    },
									    error: function(e){
									    	console.log('Oops. Error !', JSON.stringify(e));
									    	console.log(JSON.stringify({action: 'scrap'}));
									    }
									})
									.catch(function(e) {
										console.log(e);
									})
									//*/
								}, JSON.stringify(pageData));
				            })
				            .catch(function(e) {
				                console.log(e);
				            });
				        });
					})
			    });
			});
		}

		start();
	}
}

module.exports = function(app, route) {
	let camerBeScrap = new CamerBeScrapComponent();
	camerBeScrap.init(app, route);
};

