var ffmpeg = require('fluent-ffmpeg');
var ytdl = require('youtube-dl');
var fs = require('fs');
var http = require('http');
var exec = require('child_process').exec;
var moment = require('moment');
var JET = {};
var connection = false;
var nextFileLocation = './next_media.txt';
var productRoot = '/var/www/html/mediaFiles/';
var _that = this;

var nicercast = require('./nicercast_ffmpeg');


var startPlaying = function(stream) {

	JET.musicInstance = ffmpeg(stream)
	.inputOptions(['-re']) // Very important to synchronize the read vs play speeds
	// Important: Only use copy. Do not encode as it required a very powerful computer !!!
	// Do not encode, just copy the media and output to the live
	.addOptions([
        '-vcodec copy',
        '-acodec copy',
        '-f flv',
        '-y',
        '-preset ultrafast'
    ])
    .on('start', function(cmd) {
    	console.log('starting...');

        JET.durationInfo = {
            stream,
            duration: 0,
        }

        JET.progressInfo = {
            stream,
            currentPos: 0,
        }

        JET.icecastProcess && JET.icecastProcess.kill();
        playLiveAudio();
    })
    //.preset('flashvideo')
    .on('end', function() {
      console.log('file has been converted succesfully');
    })
    .on('error', function(err) {
      	console.log('an error happened: ' + err.message);
    })
    .on('progress', function(progress) {
        var currentPos = parseInt(progress.percent * JET.durationInfo.duration, 10);
        JET.progressInfo = {
            stream,
            currentPos
        }

        console.log('Processing: ' + progress.percent + '% done', JET.progressInfo);
    })
    .on('codecData', function(data) {
        var duration = moment.duration(data.duration).asSeconds();
        console.log('duration: ' + data.duration, duration + 's');
        JET.durationInfo = {
            stream,
            duration
        }
    })
    .save((function(){
		return "rtmp://jetcamer.com/show/live_hi";
    	//return "rtmp://"+ liveServerHostAddr +"/live/logo";
    }()));
}


var startPlaying_1 = function(stream) {
    (function playLiveAudio() {
        var icecastCmd = 'ffmpeg -re -i /opt/node_js/hls/live.m3u8 -vn -c:a libmp3lame -content_type audio/mpeg -b:a 128k -legacy_icecast 1 -ice_name "Raspi Test Stream of MP3" -f mp3 icecast://jetcamer:166433@jetcamer.com:8000/live.mp3';
        //var icecastCmd = 'ffmpeg -re -i rtmp://jetcamer.com/show/live -vn -c:a libmp3lame -content_type audio/mpeg -b:a 128k -legacy_icecast 1 -ice_name "Raspi Test Stream of MP3" -f mp3 icecast://jetcamer:166433@jetcamer.com:8000/live.mp3';
        exec(icecastCmd, function(error, stdout, stderr){
            JET.playLiveAudioTm && clearTimeout(JET.playLiveAudioTm);
            console.warn('started...');
            // For long compilation, this is important to restart the audio in case of error in video
            if(error) {
                JET.playLiveAudioTm = setTimeout(playLiveAudio, 1000);
            }
        });
    }());
}

var startPlaying_2 = function(stream) {
    (function playLiveAudio() {
        var icecastCmd = 'ffmpeg -i vod/prog_index.m3u8 -i vod/prog_index.m3u8 -c:a libfdk_aac -b:a 32k  -c:v libx264 -b:v 128K -f flv rtmp://jetcamer.com/show/live_hi';
        //var icecastCmd = 'ffmpeg -re -i rtmp://jetcamer.com/show/live -vn -c:a libmp3lame -content_type audio/mpeg -b:a 128k -legacy_icecast 1 -ice_name "Raspi Test Stream of MP3" -f mp3 icecast://jetcamer:166433@jetcamer.com:8000/live.mp3';
        exec(icecastCmd, function(error, stdout, stderr){
            JET.playLiveAudioTm && clearTimeout(JET.playLiveAudioTm);
            console.warn('started...');
            // For long compilation, this is important to restart the audio in case of error in video
            if(error) {
                JET.playLiveAudioTm = setTimeout(playLiveAudio, 1000);
            }
        });
    }());
}

function playLiveAudio() {
    var stream = JET.progressInfo.stream;
    var offset = JET.progressInfo.duration ? '-ss ' + JET.progressInfo.duration : '';
    console.warn(offset);

    var icecastCmd = 'ffmpeg -re ' + offset + ' -i ' + stream + ' -vn -c:a libmp3lame -content_type audio/mpeg -b:a 128k -legacy_icecast 1 -ice_name "Raspi Test Stream of MP3" -f mp3 icecast://jetcamer:166433@jetcamer.com:8000/live.mp3';
    //var icecastCmd = 'ffmpeg -re -i rtmp://jetcamer.com/show/live -vn -c:a libmp3lame -content_type audio/mpeg -b:a 128k -legacy_icecast 1 -ice_name "Raspi Test Stream of MP3" -f mp3 icecast://jetcamer:166433@jetcamer.com:8000/live.mp3';
    exec(icecastCmd, function(error, stdout, stderr){
        JET.playLiveAudioTm && clearTimeout(JET.playLiveAudioTm);
        console.warn('started...');
        // For long compilation, this is important to restart the audio in case of error in video
        if(error) {
            console.warn(error);
            JET.playLiveAudioTm = setTimeout(function() {
                playLiveAudio(stream);
            }, 1000);
        }
    });
}

startPlaying('./out.mp4');


